/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20130823-32 [Sep 16 2013]
 * Copyright (c) 2000 - 2013 Intel Corporation
 * 
 * Disassembly of /Users/mac/Desktop/DarwinDumper_3.0.0_10.03_00.29.07_MacBookPro13,3_INSYDE_Corp._X64_Sierra_16D32_mac/ACPI Tables/AML/SSDT-5.aml, Fri Mar 10 00:29:46 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000002D4 (724)
 *     Revision         0x01
 *     Checksum         0x39
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "820D    "
 *     OEM Revision     0x00000000 (0)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("/Users/mac/Desktop/DarwinDumper_3.0.0_10.03_00.29.07_MacBookPro13,3_INSYDE_Corp._X64_Sierra_16D32_mac/ACPI Tables/AML/SSDT-5.aml", "SSDT", 1, "HPQOEM", "820D    ", 0x00000000)
{
    /*
     * iASL Warning: There were 5 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, use the one of the following
     * example iASL invocations:
     *     iasl -e <ssdt1.aml,ssdt2.aml...> -d <dsdt.aml>
     *     iasl -e <dsdt.aml,ssdt2.aml...> -d <ssdt1.aml>
     */
    External (_SB_.GGOV, MethodObj)    // Warning: Unresolved Method, guessing 4 arguments (may be incorrect, see warning above)
    External (_SB_.PCI0.GEXP.GEPS, MethodObj)    // Warning: Unresolved Method, guessing 6 arguments (may be incorrect, see warning above)
    External (_SB_.PCI0.GEXP.SGEP, MethodObj)    // Warning: Unresolved Method, guessing 3 arguments (may be incorrect, see warning above)
    External (_SB_.SGOV, MethodObj)    // Warning: Unresolved Method, guessing 2 arguments (may be incorrect, see warning above)
    External (ADBG, MethodObj)    // Warning: Unresolved Method, guessing 1 arguments (may be incorrect, see warning above)

    External (BID_)
    External (EIDF)

    Scope (\)
    {
        Device (EIAD)
        {
            Name (_HID, EisaId ("INT3399"))  // _HID: Hardware ID
            Name (_S0W, Zero)  // _S0W: S0 Device Wake State
            Method (_STA, 0, Serialized)  // _STA: Status
            {
                ADBG ("EIAD STA")
                If (LEqual (BID, 0x20))
                {
                    Return (0x0F)
                }
                Else
                {
                    If (LEqual (EIDF, One))
                    {
                        Return (0x0F)
                    }
                }

                Return (Zero)
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                Name (PECE, Zero)
                Name (PECD, Zero)
                Name (DFUE, Zero)
                Name (DFUD, Zero)
                Name (OLDV, Zero)
                Name (PECV, Zero)
                Name (DFUV, Zero)
                If (LEqual (Arg0, Buffer (0x10)
                        {
                            /* 0000 */   0x1F, 0x3C, 0xF0, 0xAD, 0x76, 0xEE, 0x23, 0x4F,
                            /* 0008 */   0x9D, 0xEF, 0xCD, 0xAE, 0x22, 0xA3, 0x6A, 0xCF
                        }))
                {
                    If (LEqual (One, ToInteger (Arg1)))
                    {
                        While (One)
                        {
                            Store (ToInteger (Arg2), _T_0)
                            If (LEqual (_T_0, Zero))
                            {
                                ADBG ("EIAD F:0")
                                Return (Buffer (One)
                                {
                                     0x0F
                                })
                            }
                            Else
                            {
                                If (LEqual (_T_0, One))
                                {
                                    ADBG ("EIAD F:1")
                                    If (LNotEqual (BID, 0x20))
                                    {
                                        Store (DerefOf (Index (Arg3, Zero)), PECE)
                                        Store (DerefOf (Index (Arg3, One)), PECD)
                                        Store (\_SB.PCI0.GEXP.GEPS (Zero, 0x0C, OLDV, \_SB.PCI0.GEXP.SGEP (Zero, 0x0C, PECE), If (
                                            LGreater (PECD, Zero))
                                                {
                                                    Sleep (PECD)
                                                    \_SB.PCI0.GEXP.SGEP (Zero, 0x0C, OLDV)
                                                }, Return (Zero)), Else
                                            {
                                                If (LEqual (_T_0, 0x02))
                                                {
                                                    ADBG ("EIAD F:2")
                                                    Store (DerefOf (Index (Arg3, Zero)), DFUE)
                                                    Store (DerefOf (Index (Arg3, One)), DFUD)
                                                    If (LEqual (BID, 0x20))
                                                    {
                                                        Store (\_SB.GGOV (0x02000015, OLDV, \_SB.SGOV (0x02000015, DFUE), Else
                                                                {
                                                                    Store (\_SB.GGOV (0x02040003, OLDV, \_SB.SGOV (0x02040003, DFUE), If (LGreater (DFUD, 
                                                                        Zero))
                                                                            {
                                                                                Sleep (DFUD)
                                                                                If (LEqual (BID, 0x20))
                                                                                {
                                                                                    \_SB.SGOV (0x02000015, OLDV)
                                                                                }
                                                                                Else
                                                                                {
                                                                                    \_SB.SGOV (0x02040003, OLDV)
                                                                                }
                                                                            }), Return (Zero))
                                                                }), Else
                                                            {
                                                                If (LEqual (_T_0, 0x03))
                                                                {
                                                                    ADBG ("EIAD F:3")
                                                                    If (LEqual (BID, 0x20))
                                                                    {
                                                                        Store (\_SB.GGOV (0x02000015, DFUV, Store (One, PECV), Else
                                                                                {
                                                                                    Store (\_SB.GGOV (0x02040003, DFUV, Store (\_SB.PCI0.GEXP.GEPS (Zero, 0x0C, PECV, Return (
                                                                                        Package (0x02)
                                                                                                    {
                                                                                                        PECV, 
                                                                                                        DFUV
                                                                                                    }), Break, Return (Zero)), Return (Zero)), Return (Zero)))
                                                                                }))
                                                                    }
                                                                }
                                                            })
                                                    }
                                                }
                                            })
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

